/*
 * Copyright 2012 Adaptrex, LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.adaptrex.core.ext.rest;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adaptrex.core.utilities.StringUtilities;

/*
 * This needs lots of work...
 */
public class RestOptions {

	private Logger log = LoggerFactory.getLogger(RestOptions.class);
	private Integer start;
	private Integer limit;
	private String where;
	private Map<String, String> extraOptions = new HashMap<String, String>();
	private List<Map<String, String>> sort;
	private List<Map<String, String>> filter;
	private String include;
	private String exclude;
	private String associations;
	private String modelName;

	public RestOptions() {
	}

	@SuppressWarnings("unchecked")
	public RestOptions(Map<String, List<String>> params) {
		try {
			for (String key : params.keySet()) {
				extraOptions.put(key, params.get(key).get(0));

				if (key.equals("limit")) {
					limit = getInt(params.get(key));
					continue;
				}

				if (key.equals("start")) {
					start = getInt(params.get(key));
					continue;
				}

				if (key.equals("where")) {
					this.setWhere(params.get(key).get(0));
				}

				if (key.equals("sort")) {
					setSort((List<Map<String, String>>) StringUtilities.fromJson(params.get(key).get(0), List.class));
					continue;
				}

				if (key.equals("filter")) {
					setFilter((List<Map<String, String>>) StringUtilities.fromJson(params.get(key).get(0), List.class));
					continue;
				}

				if (key.equals("include")) {
					this.setInclude(params.get(key).get(0));
					continue;
				}
				if (key.equals("exclude")) {
					this.setExclude(params.get(key).get(0));
					continue;
				}
				if (key.equals("associations")) {
					this.setAssociations(params.get(key).get(0));
					continue;
				}
				if (key.equals("modelname")) {
					this.setModelName(params.get(key).get(0));
					continue;
				}				

			}
		} catch (Exception e) {
			log.warn("Error", e);
		}
	}

	private Integer getInt(List<String> param) {
		return Integer.valueOf((String) param.get(0));
	}

	public Map<String, String> getExtraOptions() {
		return extraOptions;
	}

	public Integer getLimit() {
		return limit;
	}

	public void setLimit(Integer limit) {
		this.limit = limit;
	}

	public Integer getStart() {
		return start;
	}

	public void setStart(Integer start) {
		this.start = start;
	}

	public String getWhere() {
		return where;
	}

	public void setWhere(String start) {
		this.where = start;
	}
	
	public List<Map<String, String>> getSort() {
		return sort;
	}

	public void setSort(List<Map<String, String>> sort) {
		this.sort = sort;
	}

	public List<Map<String, String>> getFilter() {
		return filter;
	}

	public void setFilter(List<Map<String, String>> filter) {
		this.filter = filter;
	}

	public String getExclude() {
		return exclude;
	}

	public void setExclude(String exclude) {
		this.exclude = exclude;
	}

	public String getInclude() {
		return include;
	}

	public void setInclude(String include) {
		this.include = include;
	}

	public String getAssociations() {
		return associations;
	}

	public void setAssociations(String associations) {
		this.associations = associations;
	}
	

	public String getModelName() {
		return modelName;
	}

	public void setModelName(String modelName) {
		this.modelName = modelName;
	}	
}
